package ch.kri.fhbb.RMI;

import java.rmi.*;
import java.rmi.server.*;
import ch.kri.fhbb.RMI.RmiTextObjectServer.*;

public class RmiServer extends javax.swing.JFrame {
    // Das RMI-Server-Objekt
    static RmiTextObjectServer textServer;
    
    /** Creates new form RmiServer */
    public RmiServer() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        txtData = new javax.swing.JTextArea();
        btnRegister = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridLayout(2, 2));
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jLabel1.setText("Server Data");
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        getContentPane().add(jLabel1);
        
        txtData.setText("Default text");
        getContentPane().add(txtData);
        
        btnRegister.setText("Register");
        btnRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRegisterActionPerformed(evt);
            }
        });
        
        getContentPane().add(btnRegister);
        
        pack();
    }//GEN-END:initComponents

    private void btnRegisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRegisterActionPerformed
        try {
            // Server-Objekt erzeugen
            textServer = new RmiTextObjectServer();   
            textServer.setText( txtData.getText() );
            // Registrieren mit dem Namen "textServer"
            Naming.rebind("textServer", textServer);
            btnRegister.setEnabled(false);
        }
        catch (Exception e) {
            System.err.println(e);
            System.exit(1);
        }
    }//GEN-LAST:event_btnRegisterActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new RmiServer().show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextArea txtData;
    private javax.swing.JButton btnRegister;
    // End of variables declaration//GEN-END:variables

}
